unit WebModuleUnit;

interface

uses System.SysUtils, System.Classes, Web.HTTPApp, System.StrUtils, System.Json, Dialogs;

type
  TWebModule1 = class(TWebModule)
    procedure OnReverseString(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
      var Handled: Boolean);
    procedure OnWardKubunList(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
      var Handled: Boolean);
    procedure OnPatientInfo(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
      var Handled: Boolean);
    procedure OnBedsoreBunruiList(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
      var Handled: Boolean);
    procedure OnBedsoreKubunList(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
      var Handled: Boolean);
    procedure OnPictureTransfer(Sender: TObject; Request: TWebRequest;
      Response: TWebResponse; var Handled: Boolean);
  private
    { private 錾 }
  public
    { public 錾 }
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses UDataModule_PG;

{$R *.dfm}

procedure TWebModule1.OnBedsoreBunruiList(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
var
  Arry: TJSONArray;
  Obj: TJSONObject;
begin
  //ጕ
  Obj := TJSONObject.Create;

  Response.ContentType := 'application/json; charset=utf-8';
  Arry := _DataModule_PG.GetBedsoreBunruiList;
  Obj.AddPair('Result', Arry);
  Response.Content := Obj.ToString;
end;

procedure TWebModule1.OnBedsoreKubunList(Sender: TObject; Request: TWebRequest;
  Response: TWebResponse; var Handled: Boolean);
var
  Arry: TJSONArray;
  Obj: TJSONObject;
  Bunrui: Integer;
begin
  //ጋ敪
  Obj := TJSONObject.Create;

  Response.ContentType := 'application/json; charset=utf-8';
  Bunrui := StrToIntDef(Request.QueryFields.Values['Request'], 0);
  Arry := _DataModule_PG.GetBedsoreKubunList(Bunrui);
  Obj.AddPair('Result', Arry);
  Response.Content := Obj.ToString;
end;

procedure TWebModule1.OnPatientInfo(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
var
  Obj: TJSONObject;
  PatientID: string;
begin
  //Patient Info
  Response.ContentType := 'application/json; charset=utf-8';

  PatientID := Request.QueryFields.Values['Request'];
  Obj := _DataModule_PG.GetPatientInfo(StrToIntDef(PatientID, 0));

  Response.Content := Obj.ToString;
end;

procedure TWebModule1.OnPictureTransfer(Sender: TObject; Request: TWebRequest;
  Response: TWebResponse; var Handled: Boolean);
var
  Obj, Obj2: TJSONObject;
  JSON: string;
  flg: Boolean;
  Cnt: Integer;
begin
  //摜]

  Response.ContentType := 'application/json; charset=utf-8';
  Obj := TJSONObject.ParseJSONValue(Request.Content) as TJSONObject;

  for Cnt := 0 to Obj.Count - 1 do
  begin
    if Obj.Pairs[Cnt].JsonString.Value = 'Request' then
    begin
      JSON := Obj.Get('Request').JsonValue.ToString;
    end;
  end;

  Obj2 := TJSONObject.ParseJSONValue(JSON) as TJSONObject;
  flg := _DataModule_PG.PictureTransfer(Obj2);
  if flg then
    Response.Content := 'OK'
  else
    Response.Content := 'NG';
end;

procedure TWebModule1.OnReverseString(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
var
  str: string;
  Obj: TJSONObject;
begin
  //ReverseString

  Response.ContentType := 'application/json; charset=utf-8';

  str := System.StrUtils.ReverseString(Request.QueryFields.Values['Request']);

  Obj := TJSONObject.Create;
  Obj.AddPair('Result', str);
  Response.Content := Obj.ToString;
end;

procedure TWebModule1.OnWardKubunList(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
var
  Obj: TJSONObject;
begin
  //aList
  Obj := TJSONObject.Create;
  Response.ContentType := 'application/json; charset=utf-8';
  Obj.AddPair('Result', _DataModule_PG.GetWardKubunList);
  Response.Content := Obj.ToString;
end;

end.
